=== debian/changelog ===
glibc (2.40-5) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-MAP_NORESERVE.diff: Add MAP_NORESERVE flag.
  * debian/patches/hurd-i386/git-signal-reply-port.diff: Fix hurd build
    against gcc 14.

  [ Bjarni Ingi Gislason ]
  * debian/local/manpages/update-locale.8: fix issues reported by troff.
    Closes: #1088003.

  [ Aurelien Jarno ]
  * debian/patches/any/git-iconv-do-not-report-*.patch: backport iconv return
    code with transliteration fix from upstream.  Closes: #1087670.
  * debian/debhelper.in/locales.templates: add a note to clarify that the C,
    C.UTF-8 and POSIX locales do not need to be generated.  Closes: #1091473.
  * debian/patches/git-updates.diff: update from upstream stable branch.
  * patches/any/git-posix-fix-system-when-a-child-cannot-be-created-BZ-3.patch:
    backport patch from upstream to fix return value of system() when a child
    process cannot be created.  Closes: #1088964.
  * debian/rules.d/debhelper.mk: explicitly pass the library path to
    dh_shlibdeps for multilib packages, to fix a FTBFS with rebootstrap which
    does not install the g++-XX-multilib build-dependency.  Closes: #1088166.

  [ Carles Pina i Estany ]
  * Update Catalan debconf translation.  Closes: #1091705.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 03 Jan 2025 11:56:38 +0100

glibc (2.40-4) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: Update hurd xfails.
  * debian/patches/hurd-i386/git-default_pager.h.diff: Ship
    mach/default_pager.h again.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix memory corruption with ancient i386 binaries using stdio. Closes:
      #1080244.
    - Fix FTBFS with gcc-14 on hppa.  Closes: #1084052.
    - Drop debian/patches/sparc/submitted-sparc-clone.diff (merged).
  * debian/patches/arm/git-hwcap2-constants.diff: backport for upstream to
    support HWCAP2 values on arm32.  Closes: #1086502.
  * debian/control: add Recommends: libc-dev (= ${binary:Version}) to
    libc-devtools.  Closes: #1087881.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 23 Nov 2024 14:57:03 +0100

glibc (2.40-3) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: Avoid tests overflowing memory.
  * debian/testsuite-xfail-debian.mk: Update hurd xfails.

  [ Aurelien Jarno ]
  * debian/rules: build with gcc-14.
  * debian/control.in/main: adjust g++-for-host version on arm64 to ensure
    PAC/BTI support.
  * debian/patches/git-updates.diff: update from upstream stable branch.
  * debian/patches/any/git-iconv-*: backport iconv fixes and improvement from
    upstream master.  Closes: #328303, #1000652.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 24 Sep 2024 21:46:16 +0200

glibc (2.40-2) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/debhelper.in/libc-dev.install.hurd-amd64: Add missing libm-2.39.a.
  * debian/patches/hurd-i386/git-tst-aligned-alloc-random-thread{,-mcheck}.diff:
    Link threading tests with $(shared-thread-library).
  * debian/testsuite-xfail-debian.mk: Avoid tests overflowing memory.
  * debian/testsuite-xfail-debian.mk: Update hurd xfails.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 25 Aug 2024 20:16:17 +0200

glibc (2.40-1) experimental; urgency=medium

  [ Aurelien Jarno ]
  * New upstream release.
    - debian/symbols.wildcards: add 2.40.
    - debian/patches/hurd-i386/git-context.diff: upstreamed.
    - debian/patches/hurd-i386/git-xattr.diff: upstreamed.
    - debian/patches/hurd-i386/git-proc_getchildren_rusage.diff: upstreamed.
    - debian/patches/hurd-i386/git-AT_NO_AUTOMOUNT.diff: upstreamed.
    - debian/patches/hurd-i386/git-intr-msg-clobber.diff: upstreamed.
    - debian/patches/hurd-i386/git-pthread_self.diff: upstreamed.
    - debian/patches/hurd-i386/git-pthread_self.2.diff: upstreamed.
    - debian/patches/hurd-i386/tg-sysvshm.diff: rebased.
    - debian/patches/hurd-i386/tg-sendmsg-SCM_CREDS.diff: rebased.
    - debian/patches/hurd-i386/local-exec_filename.diff: rebased.
    - debian/patches/all/local-remove-manual.diff: refreshed.
    - debian/patches/any/local-cross.patch: refreshed.
    - debian/patches/any/git-test-epoll.diff: upstreamed.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 22 Jul 2024 07:14:59 +0200

glibc (2.39-7) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-fault-64bit.diff: Fix receiving exceptions.
  * debian/patches/hurd-i386/{tg-sendmsg-SCM_CREDS.diff,tg-ifaddrs_v6.diff}:
    Fix build with gcc-14.
  * debian/sysdeps/hurd-amd64.mk: Enable mvec.
  * debian/libc0.3.symbols.hurd-amd64: Add symbols for libmvec.
  * debian/patches/hurd-i386/git-pthread_symbols.diff: Fix missing symbols.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix build with libaudit 4.0.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 14 Aug 2024 16:06:39 +0200

glibc (2.39-6) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fixes elf/check-localplt test on power* with recent binutils.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 23 Jul 2024 19:09:58 +0200

glibc (2.39-5) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-pthread_self{,.2}.diff: Fix pthread_self()
    without libpthread.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fixes stdlib/tst-swapcontext2 test on hppa.  Closes: #1076512.
  * debian/rules.d/tarball.mk: remove useless code.
  * debian/sysdeps/arm64.mk: compile with -mbranch-protection=standard on
    arm64 to enable PAC/BTI support.  Closes: #1063515.
  * debian/control.in/main: build-depends on g++13-for-host (>= 13.3.0-3) on
    arm64 to ensure PAC/BTI support in GCC.


